package org.vlescience.webservices.deployment.impl;

import org.apache.axis.types.URI;
//import java.net.URI;
import org.globus.wsrf.security.authorization.attributes.AttributeInformation;
import java.util.Vector;
import  org.globus.voms.VomsCredentialInformation;
import javax.security.auth.Subject;
import java.util.Set;
import java.util.Iterator;
import java.util.Vector;

import org.globus.wsrf.security.SecurityManager;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.globus.gsi.jaas.JaasSubject;

import org.apache.axis.MessageContext;

import org.globus.wsrf.impl.security.authentication.Constants;

public class DeploymentService  {

    static Log logger = LogFactory.getLog(DeploymentService.class);

    public java.lang.String deploy(URI gar) {
	// public java.lang.String deploy(org.apache.axis.types.URI gar) {
        // do nothing and assume success
	logCredentials();
        return "Success.\n";
    }


    private void logCredentials() {
	Subject peer = null;
        VomsCredentialInformation vomsinfo = null;
        AttributeInformation info = null;
	Vector rolesVector = null;
        MessageContext ctx = MessageContext.getCurrentContext();
	peer = (Subject) ctx.getProperty(Constants.PEER_SUBJECT);
        Set credSet = peer.getPublicCredentials();
        Iterator creds = credSet.iterator();
        while (creds.hasNext()) {
            Object o = creds.next();
	    logger.info("credential: " + o.getClass().getName() );
            if (o instanceof AttributeInformation) {
                info = (AttributeInformation) o;
                break;
            }
        }
        if (info == null) {
            logger.info("cannot retrieve credential info from message context");
        } else {
            if (!(info instanceof VomsCredentialInformation)) {
		logger.warn("credenital info from " +
                        "message context is not VOMS");
            } else {
                vomsinfo = (VomsCredentialInformation) info;
            }
        }

	if (vomsinfo != null) {
            String VO = vomsinfo.getVO();
            logger.info("VO " + VO);
	    rolesVector = vomsinfo.getAttrs();
	    for (int i=0; i<rolesVector.size(); i++) {
		logger.info("\nRoles " + rolesVector.get(i));
	    }
	}
    }
    
    
}
